<template>
  <b-container fluid>
<b-button variant="primary" class="mb-2 mr-sm-2 mb-sm-2" @click="$router.go(-1)">Назад</b-button>
    <b-card :header="caption">
      <div slot="header">
        Отчеты детально по Городу
      </div>
      <download-excel
        class   = "btn btn-success pull-right mb-sm-2"
        :data   = "tableData"
        :fields = "jsonFields"
        name    = "filename.xls">

        Скачать Excel

      </download-excel>
      <nav>
        <b-form-select type="text" v-model="selectedCity" :options="cities"  class="mb-4 mr-sm-2 col-3"></b-form-select>
      </nav>
      <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small"  :filter="filter" responsive :items="tableData" :fields="fields" :current-page="currentPage" :per-page="perPage">

        <template slot="date" slot-scope="data">
          <div v-if="data.item.date">
            {{ dateFormat(data.item.date) }}
          </div>
        </template>
        <template slot="cause" slot-scope="data">
          <div v-if="data.item.detailedCause">
            {{ data.item.cause + ", " + data.item.detailedCause }}
          </div>
          <div v-else>
            {{ data.item.cause }}
          </div>
        </template>
      </b-table>
      <nav>
        <b-pagination :total-rows="rowCount" :per-page="perPage" v-model="currentPage" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
      </nav>
    </b-card>

  </b-container>
</template>

<script>
import { ru } from 'vuejs-datepicker/dist/locale'
import Api from '@/services/Api'
import Datepicker from 'vuejs-datepicker'
import { log } from 'util';


export default {
  name: 'ReportDetails',
  components: {
    Datepicker
  },
  props: {
    caption: {
      type: String,
      default: 'Отчеты'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      ru: ru,
      jsonFields: {
        'Город' : 'city',
        'Дата' : 'date',
        'Приход' : 'profit',
        'totalOutgoes' : 'Расход',
        'totalSumm' : 'Прибыль',
      },
      items: [],
      causes: [],
      employees: [],
      data: '',
      type: 'ordinary',
      fields: [
        { key: 'city', sortable: true, label: 'Город' },
        { key: 'date', sortable: true, label: 'Дата' },
        { key: 'profit', sortable: true, label: 'Приход' },
        { key: 'totalOutgoes', sortable: true, label: 'Расход' },
        { key: 'totalSumm', sortable: true, label: 'Прибыль' },
      ],
      currentPage: 1,
      perPage: 20,
      totalRows: 0,
      rowCount: 1,
      filter: null,
      addedModal: {
        summ: '',
        comment: '',
        cause: '',
        detailedCause: '',
        employee: '',
        date: ''
      },
      reportsDetailedByCity: [],
      filterCity: [],
      cities: [],
      selectedCity: ''
    }
  },
  methods: {
    async getCities () {
      return Api().get('getCities')
    }
  },
  computed: {
    tableData() {
      return this.reportsDetailedByCity.filter(item => item.city === this.selectedCity)
    }
  },
  async beforeMount () {
    this.cities = (await this.getCities()).data.map(item => ({ value: item.name, text: item.name }))
    this.selectedCity = this.cities[0].text
    this.$route.params.props && this.$route.params.props.reportsDetailedByCity ?  this.reportsDetailedByCity = this.$route.params.props.reportsDetailedByCity : this.$router.push({
      name: 'Reports'
    });
  },
}
</script>
